# $Revision: 1.1.2.6 $, $Date: 2004/09/11 06:13:49 $
#
# Conditional build:
%bcond_without	dist_kernel	# without distribution kernel
%bcond_without	smp		# don't build SMP module
%bcond_without	userspace	# don't build userspace tools
%bcond_with	kernel		# build kernel modules
%bcond_with	verbose		# verbose build (V=1)

%define		_min_x11	4.3.0

Summary:	Linux Drivers for ATI graphics accelerators
Summary(pl):	Sterowniki do akceleratorw graficznych ATI
Name:		XFree86-driver-firegl
Version:	3.12.0
%define		_rel 1
Release:	%{_rel}
License:	ATI Binary (parts are GPL)
Vendor:		ATI
Group:		X11/XFree86
Source0:	http://www2.ati.com/drivers/linux/fglrx-4.3.0-%{version}.i386.rpm
# Source0-md5:	a9b74202635058a701c75bb19f99fb72
Patch0:		firegl-panel.patch
Patch1:		%{name}-kh.patch
URL:		http://www.ati.com/support/drivers/linux/radeon-linux.html
BuildRequires:	cpio
%{?with_dist_kernel:BuildRequires:	kernel-source >= 2.6.7}
BuildRequires:	rpmbuild(macros) >= 1.153
%{?with_userspace:BuildRequires:	qt-devel}
BuildRequires:	XFree86-devel >= %{_min_x11}
Requires:	XFree86-OpenGL-core >= %{_min_x11}
Requires:	XFree86-Xserver
Requires:	XFree86-driver-firegl(kernel)
Requires:	XFree86-libs >= %{_min_x11}
Requires:	XFree86-modules >= %{_min_x11}
Provides:	X11-OpenGL-libGL
Provides:	XFree86-OpenGL-libGL
Obsoletes:	Mesa
Obsoletes:	X11-OpenGL-libGL
Obsoletes:	XFree86-OpenGL-libGL
Obsoletes:	X11-driver-firegl
ExclusiveArch:	i586 i686 athlon pentium3 pentium4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoreqdep	libGL.so.1

%define		_prefix		/usr/X11R6
%define		_mandir		%{_prefix}/man

%description
Display driver files for the ATI Radeon 8500, 9700, Mobility M9 and
the FireGL 8700/8800, E1, Z1/X1 graphics accelerators. This package
provides 2D display drivers and hardware accelerated OpenGL.

%description -l pl
Sterowniki do kart graficznych ATI Radeon 8500, 9700, Mobility M9 oraz
graficznych akceleratorw FireGL 8700/8800, E1, Z1/X1. Pakiet
dostarcza sterowniki obsugujce wywietlanie 2D oraz sprztowo
akcelerowany OpenGL.

%package -n kernel-video-firegl
Summary:	ATI kernel module for FireGL support
Summary(pl):	Modu jdra oferujcy wsparcie dla ATI FireGL
Release:	%{_rel}@%{_kernel_ver_str}
License:	ATI
Vendor:		ATI
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel_up}
Requires(post,postun):	/sbin/depmod
Provides:	XFree86-driver-firegl(kernel)

%description -n kernel-video-firegl
ATI kernel module for FireGL support.

%description -n kernel-video-firegl -l pl
Modu jdra oferujcy wsparcie dla ATI FireGL.

%package -n kernel-smp-video-firegl
Summary:	ATI kernel module for FireGL support
Summary(pl):	Modu jdra oferujcy wsparcie dla ATI FireGL
Release:	%{_rel}@%{_kernel_ver_str}
License:	ATI
Vendor:		ATI
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel_smp}
Requires(post,postun):	/sbin/depmod
Provides:	XFree86-driver-firegl(kernel)

%description -n kernel-smp-video-firegl
ATI kernel module for FireGL support.

%description -n kernel-smp-video-firegl -l pl
Modu jdra oferujcy wsparcie dla ATI FireGL.

%prep
%setup -q -c -T
rpm2cpio %{SOURCE0} | cpio -i -d
install -d panel_src
tar -xzf usr/src/ATI/fglrx_panel_sources.tgz -C panel_src
%patch0 -p1
%{?with_dist_kernel:%patch1 -p1}

%build
%if %{with kernel}
cd lib/modules/fglrx/build_mod
cp -f 2.6.x/Makefile .
for cfg in %{?with_dist_kernel:%{?with_smp:smp} up}%{!?with_dist_kernel:nondist}; do
	if [ ! -r "%{_kernelsrcdir}/config-$cfg" ]; then
		exit 1
	fi
	rm -rf include
	install -d include/{linux,config}
	ln -sf %{_kernelsrcdir}/config-$cfg .config
	ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h include/linux/autoconf.h
	ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} include/asm
	touch include/config/MARKER
	%{__make} -C %{_kernelsrcdir} clean \
		RCS_FIND_IGNORE="-name '*.ko' -o" \
		M=$PWD O=$PWD \
		%{?with_verbose:V=1}
	%{__make} -C %{_kernelsrcdir} modules \
		M=$PWD O=$PWD \
		%{?with_verbose:V=1}
	mv fglrx{,-$cfg}.ko
done
cd -
%endif

%if %{with userspace}
%{__make} -C panel_src \
	CCFLAGS="%{rpmcflags} -DFGLRX_USE_XEXTENSIONS" \
	MK_QTDIR=/usr \
	LIBQT_DYN=qt-mt
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with kernel}
cd lib/modules/fglrx/build_mod
install -d $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}{,smp}/misc

install fglrx-%{?with_dist_kernel:up}%{!?with_dist_kernel:nondist}.ko \
	$RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/misc/fglrx.ko
%if %{with smp} && %{with dist_kernel}
install fglrx-smp.ko \
	$RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}smp/misc/fglrx.ko
%endif
cd -
%endif

%if %{with userspace}
install -d $RPM_BUILD_ROOT{%{_bindir},%{_libdir},%{_includedir}/X11/extensions} \
	$RPM_BUILD_ROOT/usr/{%{_lib},include/GL}

install usr/X11R6/bin/{fgl_glxgears,fglrxconfig,fglrxinfo} \
	$RPM_BUILD_ROOT%{_bindir}
install panel_src/fireglcontrol.qt3.gcc%(gcc -dumpversion) \
	$RPM_BUILD_ROOT%{_bindir}/fireglcontrol
cp -r usr/X11R6/lib/* $RPM_BUILD_ROOT%{_libdir}

ln -sf libGL.so.1 $RPM_BUILD_ROOT%{_libdir}/libGL.so

# OpenGL ABI for Linux compatibility
ln -sf %{_libdir}/libGL.so.1 $RPM_BUILD_ROOT/usr/%{_lib}/libGL.so.1
ln -sf %{_libdir}/libGL.so $RPM_BUILD_ROOT/usr/%{_lib}/libGL.so

install usr/include/GL/*.h $RPM_BUILD_ROOT/usr/include/GL
install usr/X11R6/include/X11/extensions/*.h $RPM_BUILD_ROOT%{_includedir}/X11/extensions
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	-n kernel-video-firegl
%depmod %{_kernel_ver}

%postun -n kernel-video-firegl
%depmod %{_kernel_ver}

%post	-n kernel-smp-video-firegl
%depmod %{_kernel_ver}smp

%postun -n kernel-smp-video-firegl
%depmod %{_kernel_ver}smp

%if %{with userspace}
%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_libdir}/libGL.so.*.*
%attr(755,root,root) %{_libdir}/libGL.so
%attr(755,root,root) %{_libdir}/libfglrx_gamma.so.*.*
# Linux OpenGL ABI compatibility symlinks
%attr(755,root,root) /usr/%{_lib}/libGL.so.1
%attr(755,root,root) /usr/%{_lib}/libGL.so

%attr(755,root,root) %{_libdir}/modules/dri/fglrx_dri.so
%attr(755,root,root) %{_libdir}/modules/drivers/fglrx_drv.o
%{_libdir}/modules/linux/libfglrxdrm.a

# -devel
#%attr(755,root,root) %{_libdir}/libfglrx_gamma.so
#%{_includedir}/X11/include/libfglrx_gamma.h
#/usr/include/GL/glxATI.h

# -static
#%{_libdir}/libfglrx_gamma.a
%endif

%if %{with kernel}
%files -n kernel-video-firegl
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/misc/*.ko*

%if %{with smp} && %{with dist_kernel}
%files -n kernel-smp-video-firegl
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}smp/misc/*.ko*
%endif
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached on <cvs_login>@pld-linux.org

$Log: XFree86-driver-firegl.spec,v $
Revision 1.1.2.6  2004/09/11 06:13:49  havner
- 3.12.0

Revision 1.1.2.5  2004/08/17 18:37:54  havner
- without kernel modules by default
- rel 3

Revision 1.1.2.4  2004/08/16 02:07:23  havner
- kernel-smp-video-firegl-$ver-1@2.6.7_3@2.6.7_3.$arch.rpm fixed.
- rel 2

Revision 1.1.2.3  2004/08/06 13:47:23  havner
- update to 3.11.1

Revision 1.1.2.2  2004/08/01 13:08:32  malekith
- fix provides in kernel-video-firegl (from X11-* to XFree86-*) to match
  requires in main package
- release 2

Revision 1.1.2.1  2004/07/29 22:31:30  havner
- XFree86 version of firegl for AC

Revision 1.60  2004/07/29 17:01:03  havner
- rel 3 for rebuild

Revision 1.59  2004/07/22 00:17:08  pluto
- fireglcontrol comes back.

Revision 1.58  2004/07/21 23:47:45  wolf
- fireglcontrol does not compile, disabling _again_

Revision 1.57  2004/07/04 19:35:08  pluto
- release 2.

Revision 1.56  2004/07/04 19:31:57  pluto
- minor fixes (build,R:,P:).

Revision 1.55  2004/07/01 17:05:46  qboosh
- fixed _noautoreqdep (it must be SONAME, not filename)

Revision 1.54  2004/07/01 16:38:16  havner
- R: OpenGL-core

Revision 1.53  2004/07/01 16:05:51  havner
- R: fixed

Revision 1.52  2004/07/01 15:49:28  havner
- renamed to X11-driver-firegl

Revision 1.51  2004/06/05 23:23:30  havner
- it does not provide X-OpenGL-core

Revision 1.50  2004/05/31 06:25:30  pluto
- BR fixed (s/kernel-module-build/kernel-source).
  firegl needs drm*.h headers.

Revision 1.49  2004/05/30 21:49:07  pluto
- BR: fixed.

Revision 1.48  2004/05/30 21:39:10  havner
- cosmetics

Revision 1.47  2004/05/30 21:18:53  pluto
- fireglcontrol enabled.

Revision 1.46  2004/05/30 20:29:03  pluto
- updated to 3.9.0.
- 2.6.7+ complaint.

Revision 1.45  2004/05/13 17:24:03  ankry
- spaces -> tabs, other cosmetics

Revision 1.44  2004/04/07 19:56:43  pluto
- done.

Revision 1.43  2004/04/07 19:36:59  pluto
- ehhh, one more fix.

Revision 1.42  2004/04/07 19:34:12  pluto
- build at 2.6.x fixed.

Revision 1.41  2004/04/07 16:25:38  pluto
- new bconds and cleanups. NFY...

Revision 1.40  2004/03/11 20:42:24  wolf
- 3.7.6

Revision 1.39  2004/03/04 14:21:51  wolf
- reverted

Revision 1.38  2004/03/04 14:02:35  wolf
- 3.7.1

Revision 1.37  2004/02/10 15:14:47  qboosh
- Linux OpenGL ABI compliance
- added standard kernel/userspace bconds
- release 2

Revision 1.36  2004/01/16 15:36:57  qboosh
- *-devel are not used in this version (make in panel_src is disabled)
- new-style bcond, use depmod macro

Revision 1.35  2004/01/16 00:46:45  alchemyx
- fixed BuildRequires (it now requires only kernel-source)
- cosmetics
- still broken passing SMP argument to make.sh (ignored by script)

Revision 1.34  2004/01/15 23:47:06  alchemyx
- missing BuildRequires

Revision 1.33  2004/01/05 16:06:51  wolf
- 3.7.0

Revision 1.32  2003/10/30 14:43:27  arekmat
- detect gcc version

Revision 1.31  2003/10/11 13:39:48  blues
- license fixed (can we it *fully* redistribute?)

Revision 1.30  2003/10/11 13:28:34  blues
- added (in theory) building of SMP module - to be tested...

Revision 1.29  2003/10/11 13:14:01  blues
- define min_xfree macro (there are separate sources for prevoius XFree's)

Revision 1.28  2003/10/11 13:09:28  blues
- cosmetics

Revision 1.27  2003/10/09 20:20:16  wolf
- 3.2.8
- it's still fucked up

Revision 1.26  2003/09/21 12:20:25  adasi
 - patch1 should be applied but only if kernel-headers are installed

Revision 1.25  2003/09/21 12:12:23  wolf
- sorry, that patch is broken:
[14:10 wolf@bajzel:~/rpm/SOURCES]% rpm -q kernel-headers |awk -F- '{print $3}'
[14:10 wolf@bajzel:~/rpm/SOURCES]% uname -r
2.4.20

Revision 1.24  2003/09/21 11:31:33  adasi
 - added kernelheaders patch

Revision 1.23  2003/09/20 17:41:46  adasi
 - Version 3.2.5
 - Based on old spec, with use of original RPM from ATI site
 - added Provides: XFree86-OpenGL-libGL etc.
 - Wolf, you won't kill me, will you?

Revision 1.22  2003/09/09 20:07:14  wolf
- reverted - colors are screwed when going x -> console -> x

Revision 1.20  2003/08/27 00:16:31  gotar
- fixed changelog trailer

Revision 1.19  2003/08/11 20:44:51  ankry
cosmetics

Revision 1.18  2003/08/04 19:07:24  wolf
- 3.2.0

Revision 1.17  2003/07/17 08:08:14  wolf
- BR: unzip

Revision 1.16  2003/07/10 12:43:56  trojan
- added using depmod macro

Revision 1.15  2003/07/06 23:27:15  blues
- many small fixes, mostly inpired by kloczek

Revision 1.14  2003/07/02 11:50:19  wolf
- libGL.so in /usr/lib

Revision 1.13  2003/06/30 09:48:36  wolf
- 2.9.13

Revision 1.12  2003/05/26 16:24:19  malekith
- massive attack: adding Source-md5

Revision 1.11  2003/05/25 05:45:22  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.10  2003/05/16 08:33:41  trojan
- fixed depmod in %%post and %%postun when build with _without_dist_kernel

Revision 1.9  2003/05/15 01:04:43  wolf
- 2.9.12 - no longer "unknown asic class" when trying to run opengl apps
- libglx.a still not fixed, time to sleep now

Revision 1.8  2003/05/14 14:42:43  qboosh
- added depmod options so modules can be installed for kernel other than running

Revision 1.7  2003/05/07 19:30:12  luzik
- rel. 2
- now fireglcontrol is compiled not just copied
- remove QWindowsStyle from fireglcontrol

Revision 1.6  2003/04/28 23:14:33  wolf
- XF 4.3, new cards support
- it seems it requires libglx.a from XFree86-OpenGL-core
- may work, or may not work, nvidia sucks

Revision 1.5  2003/03/23 23:54:59  blues
- release 2; rebuild with 2.2.25

Revision 1.4  2003/02/21 13:53:04  qboosh
- cleanup, more specific Requires (in correct package)

Revision 1.3  2002/12/12 01:33:15  blues
- spelling fixes by Tomasz "Witek" Wittner <wittt_@poczta.onet.pl>

Revision 1.2  2002/12/03 16:50:39  misiek
- updated to 2.5.1 (builds ok, no smp module)

Revision 1.1  2002/10/13 23:31:44  misiek
- initial pld release
